#include <jni.h>
#include <string>
#include "auth_check.h"
#include "noise.h"
#include "android_log.h"

extern "C" JNIEXPORT jstring JNICALL
Java_com_bytedance_android_1native_1demo_MainActivity_func_1test(JNIEnv *env, jobject thiz,
                         jstring fun_id, jstring input_file,
                         jstring output_file,
                         jstring dat_name,
                         jstring res_path) {
    std::string fun_id_s = std::string(env->GetStringUTFChars(fun_id, NULL));
    std::string input_file_s = std::string(env->GetStringUTFChars(input_file, NULL));
    std::string output_file_s = std::string(env->GetStringUTFChars(output_file, NULL));
    std::string dat_name_s = std::string(env->GetStringUTFChars(dat_name, NULL));
    std::string res_path_s = std::string(env->GetStringUTFChars(res_path, NULL));
    LOGI("fun_id:%s",fun_id_s.c_str());
    LOGI("input_file:%s",input_file_s.c_str());
    LOGI("output_file:%s",output_file_s.c_str());
    LOGI("dat_name:%s",dat_name_s.c_str());
    LOGI("res_path:%s",res_path_s.c_str());

    std::string ret_str="OK";
    if (fun_id_s.find("DENOISE_V2")!=std::string::npos){
        ret_str = noise_fun(fun_id_s,input_file_s,output_file_s,res_path_s);
    } else {
        ret_str = "demo nonsupport fun_id";
    }
    return env->NewStringUTF(ret_str.c_str());
}

extern "C" JNIEXPORT jint JNICALL
Java_com_bytedance_android_1native_1demo_MainActivity_init_1auth_1check(JNIEnv *env, jobject thiz,
                        jstring token,jstring appkey){
    const char *token_c = env->GetStringUTFChars(token, NULL);
    const char *appkey_c = env->GetStringUTFChars(appkey, NULL);
    return auth_check_init(token_c,appkey_c);
}

extern "C" JNIEXPORT jint JNICALL
Java_com_bytedance_android_1native_1demo_MainActivity_release_1auth_1check(JNIEnv *env, jobject thiz){
    return auth_check_release();
}