//
// Created by bytedance on 2021/9/28.
//

#include "help_function.h"
#include <fstream>

void interleaveToPlanarFloat(const float* source, float** destination, int num_samples, int channels){
    for (int i = 0; i < num_samples; ++i) {
        for (int j = 0; j < channels; ++j) {
            destination[j][i] = source[i * channels + j];
        }
    }
}

void planarToInterleaveFloat(const float** source, float* destination, int num_samples, int channels){
    for (int i = 0; i < num_samples; ++i) {
        for (int j = 0; j < channels; ++j) {
            destination[i * channels + j] = source[j][i];
        }
    }
}

std::vector<uint8_t> loadModelAsBinary(const std::string& path) {
    std::ifstream file(path, std::ios::binary | std::ios::ate);
    if (!file.is_open()){
        return {};
    }
    std::streamsize size = file.tellg();
    file.seekg(0, std::ios::beg);
    std::vector<uint8_t> buffer(size);
    if(file.read((char*)buffer.data(), size)) { return buffer; }
    return {};
}