#include <iostream>
#include <vector>
#include "noise.h"
#include "define.h"
#include "auth_check.h"
#include <unistd.h>

using namespace std;

int main(int argc,char **argv) {
    std::cout << "sami core demo start" << std::endl;
    string fun_id;
    string input_file;
    string output_file;
    string dat_name;

    if (argc<=3){
        cout << "usage:\n./sami_core_tob_demo -f fun_id -i input_file -o output_file -d dat_name" << endl;
        cout << "<<if you use preset effect，please set the dat_name>>" << endl;
        cout << "<<only support wav file>>" << endl;
        exit(-1);
    }

    int c = 0;
    while(EOF != (c = getopt(argc,argv,"f:i:o:d:"))){
        switch(c){
            case 'f':fun_id = optarg;break;
            case 'i':input_file = optarg;break;
            case 'o':output_file = optarg;break;
            case 'd':dat_name = optarg;break;
            default:
                cout << "\n usage: ./sami_core_tob_demo -f fun_id -i input_file -o output_file -d dat_name" << endl;
                cout << "if you use preset effect，please set the dat_name\n" << endl;
                exit(-1);
        }
    }

    cout << "***********" << endl;
    cout << "fun_id:" << fun_id << endl;
    cout << "input_file:" << input_file << endl;
    cout << "output_file:" << output_file << endl;
    cout << "dat_name:" << dat_name << endl;
    cout << "***********" << endl;

    int ret = auth_check_init(TOKEN,APPKEY);
    if (ret !=0){
        cout << "auth_check_init error:" << ret << endl;
        return -1;
    }
    string ret_str="OK";
    if (fun_id.find("DENOISE_V2")!=string::npos){
        ret_str = noise_fun(fun_id,input_file,output_file,SAMI_CORE_RES_PATH);
    } else {
        ret_str = "demo nonsupport fun_id";
        cout << ret_str << endl;
    }

    ret = auth_check_release();
    if (ret !=0){
        ret_str = ret_str + ",auth_check_release error:" + to_string(ret);
    }

    if (ret_str !="OK"){
        return -1;
    }else{
        return 0;
    }
}
